#include <bits/stdc++.h>
using namespace std;
#define TLHAdepzais1tg ios_base::sync_with_stdio(0);cin.tie();cout.tie(0);
#define ll long long
#define N 100007
#define fi first
#define se second
#define pii pair<ll,ll>
#define str string
int n,k;
ll x[N],ans;
bool check(ll res)
{
    ll kq=0;
    for(int i=2;i<=n;i++)
    {
        ll dis=x[i]-x[i-1];
        kq+=dis/res;
        if(dis%res==0)
            kq--;
    }
    return kq<=k;
}
int main()
{
    TLHAdepzais1tg;
    if(fopen("fence.inp","r"))
    {
        freopen("fence.inp","r",stdin);
        freopen("fence.out","w",stdout);
    }
    cin>>n>>k;
    for(int i=1;i<=n;i++)
        cin>>x[i];
    sort(x+1,x+n+1);
    ll l=1,r=2e9;
    while(l<=r)
    {
        ll mid=(l+r)/2;
        if(check(mid))
        {
            ans=mid;
            r=mid-1;
        }
        else
            l=mid+1;
    }
    cout<<ans;
    return 0;
}

